sub GravaCookie {

    local($cookie_name,@cookies) = @_;
    local($cookie,$value,$cookie_value);

    while ( ($cookie,$value) = @cookies ) {

        if ($cookie_value) {
            $cookie_value .= '&' . $cookie . '::' . $value;
        }
        else {
            $cookie_value = $cookie . '::' . $value;
        }

        shift(@cookies); shift(@cookies);
    }

    &SetCookies("$cookie_name","$cookie_value");
}

sub LerCookie {

    local($cookie_name,@ReturnCookies) = @_;
    local($cookie_flag) = 0;
    local($ReturnCookie,$cookie,$value);

    if (&GetCookies($cookie_name)) {

        if ($ReturnCookies[0] ne '') {

            foreach (split(/&/,$Cookies{$cookie_name})) {

                ($cookie,$value) = split(/::/);

                foreach $ReturnCookie (@ReturnCookies) {
                    if ($ReturnCookie eq $cookie) {
                        $Cookies{$cookie} = $value;
                        $cookie_flag = 1;
                    }
                }
            }
        }

        else {


            foreach (split(/&/,$Cookies{$cookie_name})) {
                ($cookie,$value) = split(/::/);


                $Cookies{$cookie} = $value;
            }
            $cookie_flag = 1;
        }

        delete($Cookies{$cookie_name});
    }

    return $cookie_flag;
}

1;

sub GetCookies {

    local(@ReturnCookies) = @_;
    local($cookie_flag) = 0;
    local($cookie,$value);

    if ($ENV{'HTTP_COOKIE'}) {

        if ($ReturnCookies[0] ne '') {

            foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {

                ($cookie,$value) = split(/=/);

                foreach $ReturnCookie (@ReturnCookies) {

                    if ($ReturnCookie eq $cookie) {
                        $Cookies{$cookie} = $value;
                        $cookie_flag = "1";
                    }
                }
            }

        }

        else {

            foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
                ($cookie,$value) = split(/=/);

                $Cookies{$cookie} = $value;
            }
            $cookie_flag = 1;
        }
    }

    return $cookie_flag;
}

sub SetCookies {

    # Localize variables and read in cookies to be set.                      #

    local(@cookies) = @_;
    local($cookie,$value,$char);

    while( ($cookie,$value) = @cookies ) {

        print "Set-Cookie: $cookie\=$value; $expira";

       print "\n";

        shift(@cookies); shift(@cookies);
    }
}

